<?php
define("THIS_FILE", "update.php");

error_reporting(E_ALL ^ E_NOTICE);
set_time_limit(600);

require_once("../config/config.inc.php");
ini_set("include_path", CWF_PATH."cwf".PATH_SEPARATOR.CWF_PATH."k_db".PATH_SEPARATOR.CWF_PATH."admin");
require_once("KDbTools.inc.php");
require_once("MainAdminUI.inc.php");
require_once("autoloader.inc.php");
autoloader::init();

CWFTools::replaceHTMLChars($_POST);
$DB = new DbConnection(DB_HOST, DB_USER, DB_PASSWD, DB_NAME);

$menu = new MainAdminUI($DB, false);

/////////////////////////////////////////////////////////////////////////////////////////////////////////
// Update statements
$UPDATES_SQL = array(
  "3.0 &alpha;11" => array(
      "ALTER TABLE users ADD COLUMN deleted tinyint;",
      "UPDATE users SET deleted=0;",
      "ALTER TABLE user_booking ADD COLUMN deleted tinyint;",
      "UPDATE user_booking SET deleted=0;",
      "ALTER TABLE user_booking_options ADD COLUMN deleted tinyint;",
      "UPDATE user_booking_options SET deleted=0;",
      "CREATE TABLE k_db_version(version text);",
      "INSERT INTO k_db_version(version) VALUES('3.0 &alpha;11');"
  ),
  "3.0 &alpha;12" => array(
      "ALTER TABLE events DROP COLUMN event_currency;",
      "UPDATE k_db_version SET version='3.0 &alpha;12';"
  ),
  "3.0 &alpha;13" => array(
      "ALTER TABLE users ADD COLUMN last_login datetime AFTER allow_email;",
      "UPDATE k_db_version SET version='3.0 &alpha;13';"
  ),
  "3.0 &alpha;14" => array(
      "ALTER TABLE user_booking ADD INDEX user_id (user_id);",
      "ALTER TABLE user_booking ADD INDEX event_id (event_id);",
      "ALTER TABLE event_fees ADD INDEX event_option_id (event_option_id);",
      "ALTER TABLE event_options ADD INDEX event_option_group_id (event_option_group_id);",
      "ALTER TABLE event_option_groups ADD INDEX event_id (event_id);",
      "ALTER TABLE kdb_log ADD INDEX db_admin_id (db_admin_id);",
      "ALTER TABLE event_options CHANGE COLUMN person_limit person_limit mediumint unsigned;",
      "UPDATE k_db_version SET version='3.0 &alpha;14';"
  ),
  "3.0 &beta;2" => array(
      "RENAME TABLE k_db_version TO kdb_version;",
      "UPDATE kdb_version SET version='3.0 &beta;2';"
  ),
  "3.0 rc8" => array(
      "ALTER TABLE db_admins ADD COLUMN admin_name text AFTER db_admin_id;",
      "UPDATE db_admins SET admin_name='root' WHERE login='root';",
      "UPDATE kdb_version SET version='3.0 rc8';"
  ),
  "3.0.0" => array(
      "ALTER TABLE events ADD COLUMN confirmation_email_wl text AFTER confirmation_email;",
      "ALTER TABLE events ADD COLUMN confirmation_text_wl text AFTER confirmation_email;",
      "UPDATE kdb_version SET version='3.0.0';"
  ),
  "3.1.0" => array(
      "CREATE TABLE db_admins_access (db_admin_id int unsigned NOT NULL, name varchar(100) NOT NULL, PRIMARY KEY(db_admin_id, name), INDEX(db_admin_id));",
      "INSERT INTO db_admins_access(db_admin_id, name) SELECT db_admin_id, 'kdb_options' FROM db_admins WHERE kdb_options>0;",
      "INSERT INTO db_admins_access(db_admin_id, name) SELECT db_admin_id, 'edit_event' FROM db_admins WHERE edit_event>0;",
      "INSERT INTO db_admins_access(db_admin_id, name) SELECT db_admin_id, 'edit_fees' FROM db_admins WHERE edit_fees>0;",
      "INSERT INTO db_admins_access(db_admin_id, name) SELECT db_admin_id, 'edit_payment' FROM db_admins WHERE edit_payment>0;",
      "INSERT INTO db_admins_access(db_admin_id, name) SELECT db_admin_id, 'edit_disclaimers' FROM db_admins WHERE edit_disclaimers>0;",
      "INSERT INTO db_admins_access(db_admin_id, name) SELECT db_admin_id, 'edit_salutations' FROM db_admins WHERE edit_salutations>0;",
      "INSERT INTO db_admins_access(db_admin_id, name) SELECT db_admin_id, 'edit_topics' FROM db_admins WHERE edit_topics>0;",
      "INSERT INTO db_admins_access(db_admin_id, name) SELECT db_admin_id, 'edit_views' FROM db_admins WHERE edit_views>0;",
      "INSERT INTO db_admins_access(db_admin_id, name) SELECT db_admin_id, 'edit_admins' FROM db_admins WHERE edit_admins>0;",
      "INSERT INTO db_admins_access(db_admin_id, name) SELECT db_admin_id, 'edit_admingroups' FROM db_admins WHERE edit_admingroups>0;",
      "INSERT INTO db_admins_access(db_admin_id, name) SELECT db_admin_id, 'add_registrations' FROM db_admins;",
      "ALTER TABLE db_admins DROP COLUMN kdb_options, DROP COLUMN edit_event, DROP COLUMN edit_fees, DROP COLUMN edit_payment, ".
      "DROP COLUMN edit_disclaimers, DROP COLUMN edit_salutations, DROP COLUMN edit_topics, DROP COLUMN edit_views, DROP COLUMN edit_admins, ".
      "DROP COLUMN edit_admingroups;",
      "UPDATE kdb_version SET version='3.1.0';"
  )
);
// Create db tables for new classes
$NEWCLASSES = array(
  "3.0 rc7" => array("Country")
);
$UPDATES_CONF = array(
  "3.0 &alpha;12" => array(
      "currency"=>"€"
  ),
  "3.0 rc7" => array(
      "returnpath_workaround"=>0
  )
);

if ($menu->writeHeader(THIS_FILE, 'K_DB Update', '')) {
  echo "<h2 class=\"first\">K_Db Update</h2>\n";

  $kdbVersion = $DB->result($DB->query("SELECT version FROM kdb_version LIMIT 1;"), 0, 0);
  if($DB->error())
    $kdbVersion = $DB->result($DB->query("SELECT version FROM k_db_version LIMIT 1;"), 0, 0);
    
  if($kdbVersion!=KDB_VERSION) {
    echo "<p>Updating K_Db".($kdbVersion ? " from version {$kdbVersion}" : "")." to ".KDB_VERSION."</p>\n";
    
    /////////////////////////////////////////////////////////////////////////////////////////////////////////
    // Update Database
    echo "<h4>Update database ...</h4>\n";
    if(!in_array(KDB_VERSION, array_keys($UPDATES_SQL)))
      $UPDATES_SQL[KDB_VERSION] = array("UPDATE kdb_version SET version='".KDB_VERSION."';");
    
    do {
      if (key($UPDATES_SQL)>$kdbVersion) break;
    } while($kdbVersion && next($UPDATES_SQL));
    
    echo "<table class=\"padding alignleft borderrows\">\n";
    while($update = current($UPDATES_SQL)) {
      foreach($update as $sql) {
        echo "<tr>\n";
        echo "  <td>{$sql}</td>\n";
        $DB->query($sql);
        if(!$DB->errno())
          echo "  <td>Success</td>\n";
        else
          echo "  <td><b>".$DB->error()."</b></td>\n";
        echo "</tr>\n";
      }
      next($UPDATES_SQL);
    }
    echo "</table>\n";

    /////////////////////////////////////////////////////////////////////////////////////////////////////////
    // New classes
    echo "<h4>Create tables for new classes ...</h4>\n";
    do {
      if (key($NEWCLASSES)>$kdbVersion) break;
    } while($kdbVersion && next($NEWCLASSES));
    
    echo "<table class=\"padding alignleft borderrows\">\n";
    while($update = current($NEWCLASSES)) {
      foreach($update as $newClass) {
        echo "<tr>\n";
        echo "  <td>{$newClass}</td>\n";
        echo "  <td>";
        $newClass::createTable($DB);
        echo "</td>\n";
        echo "</tr>\n";
      }
      next($NEWCLASSES);
    }
    echo "</table>\n";
    
    /////////////////////////////////////////////////////////////////////////////////////////////////////////
    // Update configuration file
    echo "<h4>Update configuration file ...</h4>\n";
    do {
      if (key($UPDATES_CONF)>$kdbVersion) break;
    } while($kdbVersion && next($UPDATES_CONF));
    
    echo "<table class=\"padding alignleft borderrows\">\n";

    if($update = current($UPDATES_CONF)) {
      $config = new KDbOptions(KDbOptionsUI::getValidationRules());
      $newConfArray = $config->toArray();
      do {
        foreach($update as $const => $value) {
          echo "<tr>\n";
          echo "  <td>$const</td>\n";
          echo "  <td>$value</td>\n";
          echo "</tr>\n";
          $newConfArray[$const] = $value;        
        }
      } while($update = next($UPDATES_CONF));
      if($config->fromArray($newConfArray)) {
        $config->writeData($DB);
        echo "<tr>\n  <td><b>Update status:</b></td>\n  <td>Success</td>\n</tr>";
      }
      else
        echo "<tr>\n  <td><b>Update status:</b></td>\n  <td>Validation failed.</td>\n</tr>";
    }
    else {
      echo "<tr>\n  <td><b>Update status:</b></td>\n  <td>Nothing to do.</td>\n</tr>";
      $config = new KDbOptions(KDbOptionsUI::getValidationRules());
      $config->writeData($DB);
    }
    
    echo "</table>\n";
  }
  else {
    echo "<p>K_Db database and configuration are up to date (v{$kdbVersion})</p>\n";
  }
?>


<?php
}
$menu->writeFooter();
?>
