<?php
class Plugins {
  private static $allowedHooks = array("MenuItem", "ViewButton", "ViewColumn", "RegForm");

  private static $hookMenuItem = array();
  private static $hookViewButton = array();
  private static $hookViewColumn = array();
  private static $hookRegForm = array();
  private static $addAccessRights = array();
  
  public static function addHook($hook, $class) {
    if(in_array($hook, self::$allowedHooks)) {
      $hook = "hook".$hook;
      if(!in_array($class, self::$$hook))
        array_push(self::$$hook, $class);
    }
  }

  public static function addAccessRights($accessRights) {
    foreach ($accessRights as $name => $text)
      if (!in_array($name, array_keys(static::$addAccessRights)) && !in_array($text, static::$addAccessRights))
        static::$addAccessRights[$name] = $text;
  }
  public static function getAddAccessRights() {
    return static::$addAccessRights;
  }
  
  /* Functions for MenuItem               ********************************** */
  public static function addMenuItems(CWFMainUI &$menu) {
    foreach (self::$hookMenuItem as $class)
      $class::addMenuItems($menu);
  }

  /* Functions for ViewButton             ********************************** */
  public static function addKDbViewButtons() {
    $newButtons = array();
    foreach (self::$hookViewButton as $class) {
      if($new = $class::addKDbViewButtons()) {
        $newButtons = array_merge($newButtons, $new);
      }
    }
    
    return $newButtons;
  }
  
  public static function viewButtonPushed(DbConnection $DB) {
    foreach (self::$hookViewButton as $class) {
      $buttons = $class::addKDbViewButtons();
      foreach ($buttons as $button) {
        if (isset($_POST[$button['buttonname']]) && $_POST[$button['buttonname']]) {
          $instance = new $class($DB);
          break;
        }
      }
    }
  }
  
  /* Functions for ViewColumn             ********************************** */
  public static function addViewColumns() {
    $newColumns = array();
    foreach (self::$hookViewColumn as $class) {
      foreach ($class::getProperties() as $property => $name) {
        $newColumns[] = array('name'=>$name,
                              'property'=>$property);
      }
    }
    
    return $newColumns;
  }
  
  public static function mergeUsers(DbConnection $DB, $userIdx, $mergeWithId) {
    foreach (self::$hookViewColumn as $class) {
      if(in_array("mergeUsers", get_class_methods($class)))
        $class::mergeUsers($DB, $userIds, $merge_with_id);
    }
  }
  
  public static function addViewSQL(&$columns, $columnIdx, $column) {
    foreach (self::$hookViewColumn as $class) {
      if (($displayName=$class::getProperties($column)) && ($select=$class::getPropertySelect($column))) {
        $columns[$columnIdx]['columnName'] = $column;
        $columns[$columnIdx]['displayName'] = $displayName;
        $columns[$columnIdx]['forSelect'] = $select;
        $columns[$columnIdx]['process'] = array('class'=>$class, 'function'=>'getTextView');
      }
    }
    
    return ($columnIdx+1);
  }
  /* Functions for RegForm                ********************************** */
  public static function addRegFormUI(DbConnection $DB) {
    $uis = array();
    foreach (self::$hookRegForm as $class) {
      $uis[] = new $class($DB);
    }
    return $uis;
  }
}
?>